! This subprogram computes the dynamic programming problem of consumers
! Written by Enes Sunel, May 2014

subroutine VFI

use parameters
implicit none

iteration= iteration+1

print*, 'Iteration number',iteration
print*,'--------------------------------'


!!!---------------------------------------------------------------------
!! VALUE FUNCTION ITERATION (DISCRETIZATION)
!!!---------------------------------------------------------------------


if (iteration >= 1 ) then

if (inf == .02) then

open (UNIT=7,FILE='Value.txt')             ! Reads the stored value function from the previous approximation

do i=1,na
Read (UNIT=7,FMT=*)V(i,1),V(i,2),V(i,3)
end do
close(UNIT=7)

elseif (inf == .14) then

open (UNIT=7,FILE='Value10.txt')             ! Reads the stored value function from the previous approximation

do i=1,na
Read (UNIT=7,FMT=*)V(i,1),V(i,2),V(i,3)
end do
close(UNIT=7)

end if

!V = 0.

end if

Viter  = -1.e+08
Citer  = 0.000001
diff=10.
counter=0
tol1=1.e-06

scalar1 = 1/(eta-1)

scalar2 = phi*(1+gama)

scalar3 = 1 + gama*varrho

scalar6 =  ( 1 - 1/(R_star*(1. + inf))  )/(varrho*gama*phi)

Rk_a_x = (1-tau_k)* ( (K_a_x**alpha*L_a_x**(1-alpha))**theta - delta*K_a_x - w*L_a_x ) + K_a_x

print*,'DENEME',scalar6

timesum = 0
call cpu_time(first)
call cpu_time(second)
call cpu_time(third)

DO
counter=counter+1

   if (maxval(diff) < tol1)  exit

 print*,maxval(diff)

    if (counter == 9) then
        VFI_check =  maxval(diff)
    elseif (counter == 10 .and. VFI_check < maxval(diff) ) then
    print*,'Value function is not converging!'
    end if

     do i=1,na

     scalar4 = asset(i,1) + tau - K_a_x

        do j=1,nx

        scalar5 = (1-tau_h)*w*x(j,1)

            do ii =1,nb

            if (scalar4 + scalar5*0.001  - bond(ii,1) <= 0) then                    ! Infeasible consumption levels for Newton's algorithm

                cons = 0.000001

            else

            cons = scalar4 + scalar5*0.20   - bond(ii,1)

            fc = 5

            do                                                                       ! Solve for consumption in the budget constraint by using Newton's method

            if ( fc < tol1) exit

            kap  = cons**((1-varrho)/scalar3)*scalar6**(varrho/scalar3) !CHECK OK

            hour = ( scalar5/( psi*(1+scalar2*kap**gama) ) )**scalar1   !CHECK OK        ! Computes the labor supply for a given real wage and productivity state

            fc  = scalar4 + scalar5*hour - bond(ii,1) - (cons**(1+gama)/scalar6)**(1/scalar3) - cons*(1+phi*kap**gama) !CHECK OK

            kap1 = scalar6**(varrho/scalar3)*((1-varrho)/scalar3)*cons**((1-varrho)/scalar3-1) !CHECK OK

            h1 = - scalar1 * hour**(2-eta) * (scalar5/psi) * &

                 (1+scalar2*kap**gama)**(-2) *gama*scalar2* kap**(gama-1)* kap1

            fc1 = scalar5*h1 - (1/scalar3)*(cons**(1+gama)/scalar6)**(1/scalar3 -1) * (1+gama) * & !CHECK OK

                  (cons**gama/scalar6) - (1 + phi*( kap**gama + cons*gama*kap**(gama-1)*kap1  ) ) !CHECK OK

            cons = cons - fc/fc1

            end do

!            print*,kap,'VELOCITY'

            end if

            kap  = cons**((1-varrho)/scalar3)*scalar6**(varrho/scalar3)

            hour = ( scalar5/( psi*(1+scalar2*kap**gama) ) )**scalar1           ! Computes the labor supply for a given real wage and productivity state

!            print*,hour,'HOURS'

                    if ( (cons-psi*hour**eta/eta) <=0  ) then

                        Viter(i,j,ii)= -1.e+08                             ! Imposing Inada condition

                        Citer(i,j,ii) = 0.000001

                    elseif (sigma > 1.) then

                        Viter(i,j,ii) = ( (cons - psi*hour**eta/eta)**(1-sigma) - 1 ) / (1-sigma)

                        Citer(i,j,ii) = cons

                        mon = (cons**(1+gama)/scalar6)**(1/scalar3)

                        aprime = R_star*bond(ii,1) + mon/(1+inf) + Rk_a_x     ! Evolution of wealth

                            if (aprime >= aub) then

                                aprime = aub

                            elseif (aprime <= alb) then

                                aprime = alb

                            end if

                        Lprime = int( (aprime - alb)/inca ) + 1          ! Indices of left shoulders

                        Rprime = Lprime + 1

                        LWprime = ( asset(Rprime,1) - aprime ) / inca    ! Computation of weights for tomorrow's wealth

                            if (LWprime > 1.) then

                                LWprime = 1.

                            elseif (LWprime < 0.) then

                                LWprime = 0.

                            end if

                        RWprime = 1. - LWprime

                    end if

                    do t = 1,nx

                        Viter(i,j,ii) = Viter(i,j,ii) + beta*xprob(j,t)*( LWprime*V(Lprime,t) + &

                                                                          RWprime*V(Rprime,t) )
                    end do

                end do    ! Closes the loop on jj =1,nb

            Vnext(i,j) = maxval(Viter(i,j,:))

    end do          ! Closes the loop on j =1,nx

end do              ! Closes the loop on i =1,na

    bl = (beta/(1.-beta))*minval(Vnext-V)          !Using Mc Queen-Porteus Error Bounds
    bh = (beta/(1.-beta))*maxval(Vnext-V)

    diff = maxval(abs(Vnext-V))
    V = Vnext + (bl+bh)/2.

!!!!-------------------------------------------------------------------------------
END DO                                  ! Value function iteration ends
!!!!-------------------------------------------------------------------------------

do i=1,na
WRITE(UNIT=7,FMT=*)V(i,1),V(i,2),V(i,3)
end do

call cpu_time(fourth)
timesum = timesum + (fourth-third) - (second-first)   ! Computes the duration of VFI execution
print*,'-------------------------'
print '("Sum = ",f6.3," seconds.")',timesum
print*,'-------------------------'


print*, 'Value function converged in',counter,'iterations'
print*,'-----------------------------------------------------'

    end subroutine VFI
