%% FIGURE 5: LORENZ CURVES AND PORTFOLIO COMPOSITION IN THE LOW-INFLATION STEADY STATE
%% TABLE 2: GINI COEFFICIENTS FOR KEY MODEL VARIABLES IN THE LOW-INFLATION STEADY STATE

%close all
% % PORTFOLIO DISTRIBUTION FROM DATA
y0208 = [0 .2 .4 .6 .8 1
                0.000	0.06	0.16	0.31	0.53	1.000];

m0208=[	0.00	0.9732	0.9930	0.9989	0.9997	0.9998
       	0.00	0.2111	0.3825	0.5757	0.7059	1.0000];

b0208=[0.0000	0.7044	0.9161	0.9873	0.9969	0.9999
                0.0000	0.0962	0.2807	0.5028	0.6330	0.9957];
                
a0208=[0.0000	0.9441	0.9847	0.9978	0.9995	1.0000
                0.0000	0.1173	0.2999	0.5160	0.6473	1.0000];

c0208 = [0 .2 .4 .6 .8 1
                 0.000	0.070	0.19	0.35	0.57	1.000];


 % LORENZ FOR VARIABLES
x = [0:1/(length(IncomeIneq)-1):1];
figure
subplot(3,2,1)
plot(IncomeIneq(:,1),IncomeIneq(:,2),'LineWidth',2.5)
hold on
plot(y0208(1,:),y0208(2,:),'r--*','LineWidth',2.5)
hold on
plot(x,x,'--','LineWidth',1.5)
axis([0 1 0 1])
grid
title('Lorenz curve for income')
ylabel('Cumulative fraction of income') 
 
x = [0:1/(length(WealthIneq)-1):1];
subplot(3,2,2)
plot(PortfolioIneq(:,5),PortfolioIneq(:,6),'LineWidth',2.5)
hold on
plot(c0208(1,:),c0208(2,:),'r--*','LineWidth',2.5)
hold on
plot(x,x,'--','LineWidth',1.5)
axis([0 1 0 1])
grid
title('Lorenz curve for consumption')
ylabel('Cumulative fraction of consumption')

x = [0:1/(length(WealthIneq)-1):1];
subplot(3,2,3)
plot(PortfolioIneq(:,7),PortfolioIneq(:,8),'LineWidth',2.5)
hold on
plot(a0208(1,:),a0208(2,:),'r--*','LineWidth',2.5)
hold on
plot(x,x,'--','LineWidth',1.5)
axis([0 1 0 1])
grid
title('Lorenz curve for financial assets')
ylabel('Cumulative fraction of financial assets')


x = [0:1/(length(PortfolioIneq)-1):1];
subplot(3,2,4)
plot(PortfolioIneq(:,1),PortfolioIneq(:,2),'LineWidth',2.5)
hold on
plot(b0208(1,:),b0208(2,:),'r--*','LineWidth',2.5)
hold on
plot(x,x,'--','LineWidth',1.5)
axis([0 1 0  1])
grid
title('Lorenz curve for term deposits')
xlabel('Cumulative fraction of agents')
ylabel('Cumulative fraction of term deposits')

x = [0:1/(length(PortfolioIneq)-1):1];
subplot(3,2,5)
plot(PortfolioIneq(:,3),PortfolioIneq(:,4),'LineWidth',2.5)
hold on
plot(m0208(1,:),m0208(2,:),'r--*','LineWidth',2.5)
hold on
plot(x,x,'--','LineWidth',1.5)
axis([0 1 0  1])
grid
title('Lorenz curve for money')
xlabel('Cumulative fraction of agents')
ylabel('Cumulative fraction of money')


subplot(3,2,6)
plot([1:5],[0.6403	0.8272	0.8354	0.8129	0.8413],'r--*','LineWidth',2.5)
hold on
plot([1:5],Shares(:,6),'LineWidth',2.5)
axis([1 5 .6 1])
grid
xlabel('Asset Bins')
ylabel('Portfolio share of term deposits')
legend('Data','Model')

display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')
display('~~~~~~~~~HIGH INFLATION~~~~~~~~~~~~~~~~~~~~~~~~')
display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')

display('The Gini Coefficient of Total Deposits is: ')
2*(0.5-trapz(PortfolioIneq10(:,7),PortfolioIneq10(:,8)))
display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')

%GINI COEFFICIENT
display('The Gini Coefficient of Bonds is')
2*(0.5-trapz(PortfolioIneq10(:,1),PortfolioIneq10(:,2)))
display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')

%GINI COEFFICIENT
display('The Gini Coefficient of Money  is')
2*(0.5-trapz(PortfolioIneq10(:,3),PortfolioIneq10(:,4)))
display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')

%GINI COEFFICIENT
display('The Gini Coefficient of Consumption is')
2*(0.5-trapz(PortfolioIneq10(:,5),PortfolioIneq10(:,6)))
display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')

%GINI COEFFICIENT
display('The Gini Coefficient of Income is')
2*(0.5-trapz(IncomeIneq10(:,1),IncomeIneq10(:,2)))

display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')
display('~~~~~~~~~LOW INFLATION~~~~~~~~~~~~~~~~~~~~~~~~')
display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')


display('The Gini Coefficient of Total Deposits is: ')
2*(0.5-trapz(PortfolioIneq(:,7),PortfolioIneq(:,8)))
display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')
display('The Gini Coefficient of Total Deposits in DATA')
2*(0.5-trapz(a0208(1,:),a0208(2,:)))
display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')


%GINI COEFFICIENT
display('The Gini Coefficient of Bonds is')
2*(0.5-trapz(PortfolioIneq(:,1),PortfolioIneq(:,2)))
display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')
display('The Gini Coefficient of Bonds in DATA')
2*(0.5-trapz(b0208(1,:),b0208(2,:)))
display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')

%GINI COEFFICIENT
display('The Gini Coefficient of Money  is')
2*(0.5-trapz(PortfolioIneq(:,3),PortfolioIneq(:,4)))
display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')
display('The Gini Coefficient of Money in DATA')
2*(0.5-trapz(m0208(1,:),m0208(2,:)))
display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')

%GINI COEFFICIENT
display('The Gini Coefficient of Consumption is')
2*(0.5-trapz(PortfolioIneq(:,5),PortfolioIneq(:,6)))
display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')
display('The Gini Coefficient of Consumption in DATA')
2*(0.5-trapz(c0208(1,:),c0208(2,:)))
display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')

%GINI COEFFICIENT
display('The Gini Coefficient of Income is')
2*(0.5-trapz(IncomeIneq(:,1),IncomeIneq(:,2)))
display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')
display('The Gini Coefficient of Income in DATA')
2*(0.5-trapz(y0208(1,:),y0208(2,:)))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
