%% FIGURE 4: INDIVIDUAL VALUE AND POLICY FUNCTIONS IN THE LOW-INFLATION STEADY STATE

% close all
figure
subplot(3,2,1)
plot(Wealth(a1:na,1),Value(a1:na,1),'r--','LineWidth',2.5)
hold on
plot(Wealth(a1:na,1),Value(a1:na,2),'k-.','LineWidth',2.5,'MarkerSize',3.)
hold on
plot(Wealth(a1:na,1),Value(a1:na,3),'LineWidth',2.5)
title('Value function')
ylabel('V_t')
grid
axis( [5 19  -140 0 ] )

subplot(3,2,2)
plot(Wealth(a1:na,1),B_prime(a1:na,1),'r--','LineWidth',2.5)
hold on
plot(Wealth(a1:na,1),B_prime(a1:na,2),'k-.','LineWidth',2.5,'MarkerSize',3.)
hold on
plot(Wealth(a1:na,1),B_prime(a1:na,3),'LineWidth',2.5)
grid
title('Term deposits policy')
ylabel('b_{t+1}')
axis( [5 19  0 15 ] )

subplot(3,2,3)
plot(Wealth(a1:na,1),C_prime(a1:na,1),'r--','LineWidth',2.5)
hold on
plot(Wealth(a1:na,1),C_prime(a1:na,2),'k-.','LineWidth',2.5,'MarkerSize',3.)
hold on
plot(Wealth(a1:na,1),C_prime(a1:na,3),'LineWidth',2.5)
grid
title('Consumption policy')
axis( [4.75 19.75 0 3 ] )
ylabel('c_t')

subplot(3,2,4)
plot(Wealth(a1:na,1),C_prime(a1:na,1)./(M_prime(a1:na,1)),'r--','LineWidth',2.5)
hold on
plot(Wealth(a1:na,1),C_prime(a1:na,2)./(M_prime(a1:na,2)),'k-.','LineWidth',2.5,'MarkerSize',3.)
hold on
plot(Wealth(a1:na,1),C_prime(a1:na,3)./(M_prime(a1:na,3)),'LineWidth',2.5)
title('Consumption velocity implied by policy')
ylabel('c_t/m_{t+1}')
grid
axis( [4.75 19.75  0 20 ] )

subplot(3,2,5)
plot(Wealth(a1:na,1),H_prime(a1:na,1),'r--','LineWidth',2.5)
hold on
plot(Wealth(a1:na,1),H_prime(a1:na,2),'k-.','LineWidth',2.5,'MarkerSize',3.)
hold on
plot(Wealth(a1:na,1),H_prime(a1:na,3),'LineWidth',2.5)
grid
title('Labor supply policy')
xlabel('a_t')
ylabel('h_{t}')
axis( [4.75 19.75  0.1 0.6 ] )

subplot(3,2,6)
plot(Wealth(a1:na,1),A_prime(a1:na,1),'r--','LineWidth',2.5)
hold on
plot(Wealth(a1:na,1),A_prime(a1:na,2),'k-.','LineWidth',2.5,'MarkerSize',3.)
hold on
plot(Wealth(a1:na,1),A_prime(a1:na,3),'LineWidth',2.5)
grid
title('Evolution of total wealth')
xlabel('a_t')
ylabel('a_{t+1}')
axis( [4.75 19.75 5 22 ] )
legend('High x_t','Medium x_t','Low x_t','Orientation','Horizontal')
%%