! @c Enes Sunel
! Solution of the transitional dynamics from switcing to 10% inflation economy from 2% inflation economy in the environment of Sunel (2010)
! You can use this code with any purpose at your own risk.

! PERIOD 1 IN THE ALGORITHM STANDS FOR t = 0 WHICH IS THE HIGH INFLATION STATIONARY STATE

program main
use parameters
implicit none

call Initialize

print*,'---------------------------------------------------------------------'
print*,'AUB :',aub,'BUB :',bub
print*,'---------------------------------------------------------------------'
print*,'AlB :',alb,'BlB :',blb
print*,'---------------------------------------------------------------------'
print*,'SIZE OF a:',na,'SIZE OF b:',nb
print*,'---------------------------------------------------------------------'

!!! INITIAL AND TERMINAL CONDITIONS FOR THE TRANSITIONAL DYNAMICS EXERCISE !!!

!-------------------------------------------------------------------

!! Initial Conditions

open (UNIT=7,FILE='A_dist10.txt')
do i=1,na
Read (UNIT=7,FMT=*)invasset_0(i,1),invasset_0(i,2),invasset_0(i,3)
end do
close(UNIT=7)
!-------------------------------------------------------------------
open (UNIT=7,FILE='A_prime10.txt')
do i=1,na
Read (UNIT=7,FMT=*)a_policy_0(i,1),a_policy_0(i,2),a_policy_0(i,3)
end do
close(UNIT=7)
!-------------------------------------------------------------------
open (UNIT=7,FILE='B_prime10.txt')
do i=1,na
Read (UNIT=7,FMT=*)b_policy_0(i,1),b_policy_0(i,2),b_policy_0(i,3)
end do
close(UNIT=7)
!-------------------------------------------------------------------
open (UNIT=7,FILE='M_prime10.txt')
do i=1,na
Read (UNIT=7,FMT=*)m_policy_0(i,1),m_policy_0(i,2),m_policy_0(i,3)
end do
close(UNIT=7)
!-------------------------------------------------------------------
open (UNIT=7,FILE='C_prime10.txt')
do i=1,na
Read (UNIT=7,FMT=*)c_policy_0(i,1),c_policy_0(i,2),c_policy_0(i,3)
end do
close(UNIT=7)
!-------------------------------------------------------------------
open (UNIT=7,FILE='Kappa_prime10.txt')
do i=1,na
Read (UNIT=7,FMT=*)kap_policy_0(i,1),kap_policy_0(i,2),kap_policy_0(i,3)
end do
close(UNIT=7)
!-------------------------------------------------------------------
open (UNIT=7,FILE='H_prime10.txt')
do i=1,na
Read (UNIT=7,FMT=*)h_policy_0(i,1),h_policy_0(i,2),h_policy_0(i,3)
end do
close(UNIT=7)
!-------------------------------------------------------------------
open (UNIT=7,FILE='Value10.txt')
do i=1,na
Read (UNIT=7,FMT=*)V_0(i,1),V_0(i,2),V_0(i,3)
end do
close(UNIT=7)
!-------------------------------------------------------------------
open (UNIT=1,FILE='Aggregates10.txt',STATUS='old',ACTION='read')
        READ(1,*) (aggregates(1,i), i=1,16)
close (UNIT=1)
!-------------------------------------------------------------------
! Initial Equilibrium Objects and Aggregates

Y_0 = aggregates(1,1)
C_0 = aggregates(1,2)
H_0 = aggregates(1,3)
B_0 = aggregates(1,4)
M_0 = aggregates(1,5)
K_0 = aggregates(1,6)
L_0 = aggregates(1,7)
G_0 = aggregates(1,8)
TR_0= aggregates(1,9)
R_star_0 = aggregates(1,12)
tau_0 = aggregates(1,15)

tau_hstar_0  =  0.21                    ! Equilibrium labor income-tax rate in the stationary e=14% economy
wstar_0    =  1.4802204370498657        ! Equilibrium real wage in the stationary e=14% economy

!-------------------------------------------------------------------
!! Terminal Conditions

open (UNIT=7,FILE='A_dist.txt')
do i=1,na
Read (UNIT=7,FMT=*)invasset_T4(i,1),invasset_T4(i,2),invasset_T4(i,3)
end do
close(UNIT=7)
!-------------------------------------------------------------------
open (UNIT=7,FILE='A_prime.txt')
do i=1,na
Read (UNIT=7,FMT=*)a_policy_T4(i,1),a_policy_T4(i,2),a_policy_T4(i,3)
end do
close(UNIT=7)
!-------------------------------------------------------------------
open (UNIT=7,FILE='B_prime.txt')
do i=1,na
Read (UNIT=7,FMT=*)b_policy_T4(i,1),b_policy_T4(i,2),b_policy_T4(i,3)
end do
close(UNIT=7)
!-------------------------------------------------------------------
open (UNIT=7,FILE='M_prime.txt')
do i=1,na
Read (UNIT=7,FMT=*)m_policy_T4(i,1),m_policy_T4(i,2),m_policy_T4(i,3)
end do
close(UNIT=7)
!-------------------------------------------------------------------
open (UNIT=7,FILE='C_prime.txt')
do i=1,na
Read (UNIT=7,FMT=*)c_policy_T4(i,1),c_policy_T4(i,2),c_policy_T4(i,3)
end do
close(UNIT=7)
!-------------------------------------------------------------------
open (UNIT=7,FILE='Kappa_prime.txt')
do i=1,na
Read (UNIT=7,FMT=*)kap_policy_T4(i,1),kap_policy_T4(i,2),kap_policy_T4(i,3)
end do
close(UNIT=7)
!-------------------------------------------------------------------
open (UNIT=7,FILE='H_prime.txt')
do i=1,na
Read (UNIT=7,FMT=*)h_policy_T4(i,1),h_policy_T4(i,2),h_policy_T4(i,3)
end do
close(UNIT=7)
!-------------------------------------------------------------------
open (UNIT=7,FILE='Value.txt')
do i=1,na
Read (UNIT=7,FMT=*)V_T4(i,1),V_T4(i,2),V_T4(i,3)
end do
close(UNIT=7)
!-------------------------------------------------------------------
open (UNIT=1,FILE='Aggregates.txt',STATUS='old',ACTION='read')
        READ(1,*) (aggregates(1,i), i=1,16)
close (UNIT=1)
!-------------------------------------------------------------------
! Terminal Equilibrium Objects and Aggregates

Y_T4 = aggregates(1,1)
C_T4 = aggregates(1,2)
H_T4 = aggregates(1,3)
B_T4 = aggregates(1,4)
M_T4 = aggregates(1,5)
K_T4 = aggregates(1,6)
L_T4 = aggregates(1,7)
G_T4 = aggregates(1,8)
TR_T4= aggregates(1,9)
R_star_t(1,T4) = aggregates(1,12)
tau_T4  =  aggregates(1,15)

tau_hstar_T4  =  0.21393750421702862      ! Equilibrium labor income-tax rate in the stationary e=2% economy
wstar_T4    =  1.4796875193715096         ! Equilibrium real wage in the stationary e=2% economy

!!! Initialize prices and government policy

R_star_t = R_star_0              ! Realizations of the real interest rate
tau_k_t = tau_k                  ! Realizations of capital income tax rate
tau_t = tau_0                ! Realizations of transfers

inf_t = 0.02

do t=1,T1
inf_t(1,t) = 0.14                     ! Realizations of inflation rate in the pre-disinflation window
end do

open (UNIT=1,FILE='disinflation.txt',STATUS='old',ACTION='read')                       ! Calibrated path for the inflation rate
        READ(1,*) (inf_t(1,i), i=T1+1,T2-1)
close (UNIT=1)

tau_h_diff_t = 10
wdiff_t = 10
PS_t = 10
L_H_t = 10
ED_t = 10
counter = 0
tol1 = 1.e-05


Print*,'-------------------------------------------------'
Print*,'Iterating over labor income tax sequence starts!'
Print*,'-------------------------------------------------'

tau_h_t = tau_hstar_T4                  ! Realizations of labor income tax rate

do t=1,T1
tau_h_t(1,t) = tau_hstar_0              ! Realizations of taxes in the pre-disinflation window
end do

open (UNIT=1,FILE='Labor_tax_rates.txt',STATUS='old',ACTION='read')                       ! Initial taxes sequence
        READ(1,*) (tau_h_t(1,i), i=T1+1,T2-1)
close (UNIT=1)

!print*,'Path of Taxes is',tau_h_t(1,1:T3+10)
!print*,'-----------------------------------------------'

w_t = wstar_T4                      ! Initial real wages sequence

do t=1,T1
w_t(1,t) = wstar_0                     ! Realizations of wage rate in the pre-disinflation window
end do
open (UNIT=1,FILE='Wages.txt',STATUS='old',ACTION='read')                           ! Initial transfers sequence
        READ(1,*) (w_t(1,i), i=T1+1,T2-1)
close (UNIT=1)

!print*,'Path of Real Wages is',w_t(1,1:T4)
!Print*,'-----------------------------------------------'

tau_h_t_next(1,T4) = tau_hstar_T4
w_t_next(1,T4) = wstar_T4
G_t = 0.133*0.7927                ! Government expenditures are constant

!print*,'Path of Government spending is',G_t
!Print*,'-----------------------------------------------'

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!! These lines follow in case the initial and terminal states are the same

stationary = 2          ! Indicator for stationary state = 1 means that the economy is always in the high inflation regime

if (stationary == 1) then

invasset_T4 = invasset_0           ! Always high inflation
b_policy_T4 = b_policy_0
c_policy_T4 = c_policy_0
h_policy_T4 = h_policy_0
m_policy_T4 = m_policy_0
a_policy_T4 = a_policy_0
tau_hstar_T4 = tau_hstar_0
wstar_T4 = wstar_0
TR_T4 = TR_0
V_T4  = V_0
C_T4 = C_0
H_T4 = H_0
K_T4 = K_0
L_T4 = L_0
Y_T4 = Y_0
B_T4 = B_0
M_T4 = M_0

inf_t = 0.14
tau_h_t = tau_hstar_0
w_t = wstar_0
tau_h_t_next(1,T4) = tau_hstar_0
w_t_next(1,T4) = wstar_0
!
!invasset_0 = invasset_T4            ! Always low inflation
!b_policy_0 = b_policy_T4
!c_policy_0 = c_policy_T4
!h_policy_0 = h_policy_T4
!m_policy_0 = m_policy_T4
!a_policy_0 = a_policy_T4
!tau_hstar_0 = tau_hstar_T4
!wstar_0 = wstar_T4
!TR_0 = TR_T4
!V_0  = V_T4
!C_0 = C_T4
!H_0 = H_T4
!K_0 = K_T4
!L_0 = L_T4
!Y_0 = Y_T4
!B_0 = B_T4
!M_0 = M_T4
!
!inf_t = 0.02
!tau_h_t = tau_hstar_T4
!w_t = wstar_T4
!tau_h_t_next(1,T4) = tau_hstar_T4
!w_t_next(1,T4) = wstar_T4


print*,'------------------------------------------------'
print*,'Initial and Terminal Conditions are THE SAME! '

end if

!!! These lines follow in case the initial and terminal states are the same
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

print*,'------------------------------------------------------'
print*,'Initial,  C, K, B, M', C_0, K_0,B_0,M_0
print*,'------------------------------------------------------'
print*,'Terminal, C, K, B, M', C_T4, K_T4, B_T4,M_T4
print*,'------------------------------------------------------'
print*,'Initial and Terminal Conditions are Determined! '
print*,'------------------------------------------------------'
print*,'T1 :',T1,'T2 :',T2,'T3 :',T3,'T4 :',T4
print*,'------------------------------------------------------'

tau1_t = 3.85E-002

tau2_t = 2.250E-002

!tau_t = tau2_t

!!-----------------------------------------------------------------------------------
DO
!!!-----------------------------------------------------------------------------------
counter = counter + 1

!if (counter==5) exit

Print*,'Iteration number: ',counter
print*,'------------------------------------------------------'                                                                ! Exogenous stream of government spending

    if ( max( max( maxval(tau_h_diff_t(1,1:T4-1)),maxval(abs(PS_t(1,1:T4-1))) ) ,&

               max( maxval(wdiff_t(1,1:T4-1)),maxval(abs(L_H_t(1,1:T4-1))) )  ) <= 2.5e-03 ) exit

call FinDecision        ! Computes the time variant decision rules along the transition

call FinDistribution    ! Computes the time variant distributions and sequences of aggregates

!!!-----------------------------------------------------------------------------------
END DO
!!!-----------------------------------------------------------------------------------

call FinInequality      ! Computes the time variant distributional variables

call DTIME(VALUES, TIME)

call Output

Print*,'Transition path has been solved for!'
print*,'--------------------------------------'
print*,'Execution time is',time/60,'minutes'
print*,'--------------------------------------'

diff = assetdist(:,:,T3) - invasset_T4
tau_hdif = tau_h_t_next(1,T3) - tau_hstar_T4
wdif = w_t_next(1,T3) - wstar_T4
tol1 = 1.e-04

end program main
