%% FIGURE 10: DISTRIBUTIONAL ASPECTS WHEN INTEREST RATES DEPEND ON INFLATION

close all
figure
subplot(2,2,1)
t=na*nx;
plot(Bonds(1:t,1),PortfolioIneq(2:t+1,1),'r--','LineWidth',2)
hold on 
plot(Bonds10(1:t,1),PortfolioIneq10(2:t+1,1),'LineWidth',2)
xlabel('Term deposits')
title('Cumulative distribution function')
grid
axis([blb 14.5 0. 1 ])
legend('\epsilon = 2%','\epsilon = 14%')

subplot(2,2,2)
t=na*nx;
plot(Money(1:t,1),PortfolioIneq(2:t+1,3),'r--','LineWidth',2)
hold on 
plot(Money10(1:t,1),PortfolioIneq10(2:t+1,3),'LineWidth',2)
xlabel('Money')
title('Cumulative distribution function')
grid
axis([0 0.8 0. 1 ])
legend('\epsilon = 2%','\epsilon = 14%')

subplot(2,2,3)
plot([1:5],[0.6403	0.8272	0.8354	0.8129	0.8413],'r--*','LineWidth',2)
hold on
plot([1:5],Shares(:,6),'LineWidth',2)
grid
xlabel('Asset bins')
ylabel('Portfolio share of term deposits')
legend('Data','Model')

subplot(2,2,4)
plot(Wealth(a1:na,1),	abs(B_prime(a1:na,2)) ./ ( abs(B_prime(a1:na,2))  + M_prime(a1:na,2)  )	,'r--','LineWidth',2)
hold on
plot(Wealth(a1:na,1),	abs(B_prime10(a1:na,2)) ./ ( abs(B_prime10(a1:na,2))  + M_prime10(a1:na,2)  ) ,'LineWidth',2.)
axis([4.25 10 0. 1. ])
grid
title('Portfolio share of term deposits and inflation, x = x^{medium}')
xlabel('Total wealth')
legend('\epsilon = 2%','\epsilon = 14%')
