%% FIGURE 9: TRANSITION DYNAMICS OF DISINFLATION UNDER DECLINING INTEREST RATES

close all
X = [-4.75:.25:t4/4]';
window = 4;
figure
subplot(5,2,1)
input = [inf_t(1)*ones(19,1); inf_t; inf_t(t4) ];
ma = filter(ones(1,window)/window, 1, input);
plot( X , ma,'LineWidth',2)
title('Inflation')
grid
ylabel('level')
axis([-1 10 .01 .16])

subplot(5,2,2)
input = [vel_0*ones(19,1); vel_t; vel_t4 ];
ma = filter(ones(1,window)/window, 1, input);
plot( X , ma, 'LineWidth',2)
title('Consumption velocity of money')
grid
axis([-1 10 2 20])

subplot(5,2,3)
input =  [port_0*ones(19,1) ;  port_t; port_t(t4)];
ma = filter(ones(1,window)/window, 1, input);
plot( X , ma,'LineWidth',2)
title('Share of term deposits')
ylabel('Level')
grid
axis([-1 10 .97 1])

subplot(5,2,4)
input = [ones(19,1); y_t/y_0; y_t(t4)/y_0 ] ;
ma = filter(ones(1,window)/window, 1, input);
plot( X , ma,'LineWidth',2)
title('GDP')
grid
ylabel('Relative to pre-disinflation')
axis([-1 10 0.98 1.10])

subplot(5,2,5)
input = [ones(19,1); c_y/c_y_0;  c_y(t4)/c_y_0 ];
ma = filter(ones(1,window)/window, 1, input);
plot( X,ma,'LineWidth',2)
title('Consumption-to-GDP ratio')
ylabel('Relative to pre-disinflation')
grid
axis([-1 45 .70 1.10])

subplot(5,2,6)
input = [ones(19,1); inv_y/inv_y_0;  inv_y(t4)/inv_y_0 ];
ma = filter(ones(1,window)/window, 1, input);
plot( X , ma,'LineWidth',2)
title('Investment-to-GDP ratio')
grid
axis([-1 10 .90 1.50])

subplot(5,2,7)
input = [nx_y_0*ones(19,1); nx_y;  (b_t4 - R_star*b_t(t4))/y_t4 ];
ma = filter(ones(1,window)/window, 1, input);
plot( X , ma,'LineWidth',2)
title('Net exports-to-GDP ratio')
grid
ylabel('Level')
axis([-1 45  -.25  0.0])

subplot(5,2,8)
input = [ones(19,1); w_t/w_0; w_t(t4)/w_0];
ma = filter(ones(1,window)/window, 1, input);
plot( X , ma,'LineWidth',2)
title('Real wage')
grid
ylabel('Relative to pre-disinflation')
axis([-1 10 0.99 1.07])

subplot(5,2,9)
input = [ones(19,1); tau_y/tau_y_0; tau_y(t4)/tau_y_0];
ma = filter(ones(1,window)/window, 1, input);
plot( X , ma,'LineWidth',2)
title('Transfers-to-GDP ratio')
grid
xlabel('Years')
ylabel('Relative to pre-disinflation')
axis([-1 10 0.975 1.075])

subplot(5,2,10)
input =  [ones(19,1); h_t/h_0; h_t(t4)/h_0];
ma = filter(ones(1,window)/window, 1, input);
plot( X , ma,'LineWidth',2)
title('Labor hours')
grid
xlabel('Years')
axis([-1 10 0.99 1.03])
%%
