% close all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% WELFARE GAINS OF TRANSITION
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
s = 1;

%% AGGREGATION IS CARRIED OVER THE INITIAL DISTRIBUTION

a1 = max(find(Wealth(1:na/2,5)==0));

if s==1
    
display('Aggregate over intial distribution: ')
display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')
	
% Gradual	

gain_ax1  =    100*(    (  ( V_transition*(1-beta)*(1-sigma) + 1 )./( V_0*(1-beta)*(1-sigma) + 1 )   ).^ (1/(1-sigma) )   -   1     )  ;

wegain_ax1  = gain_ax1.*A_dist10;

agg_gain1 = sum(sum(wegain_ax1));

agg_gain_EG1  =    100*(  (   (    sum(sum(V_transition.*A_dist10))*(1-beta)*(1-sigma) + 1 )./( sum(sum(V_0.*A_dist10))*(1-beta)*(1-sigma) + 1 )   ).^ (1/(1-sigma) )   -   1   )  ;

display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')
display('CE_Egalitarian welfare gain from gradual disinflation : ')
agg_gain_EG1
display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')
display('CE_Utilitarian welfare gain from gradual disinflation is: ')
agg_gain1
display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')

%% Disaggregated welfare gains from transition

inv_x = [ 0.045471   0.909054   0.045471];

ind = min(find((WealthIneq10(:,1))>=.20));

lw = 1 - (.20 - WealthIneq10(ind-1,1) ) / ( WealthIneq10(ind,1) - WealthIneq10(ind-1,1) );
 
gain_ax1(ind-2,:) ;
  
g20 = lw*gain_ax1(ind-2,:) + (1-lw)*gain_ax1(ind-1,:);

gain_ax1(ind-1,:);

display('Welfare gain of the bottom quintile - Transition ')
  
gain_bottom20 = sum(sum( [ gain_ax1(1:ind-2,:); g20  ].*[A_dist10(1:ind-2,:);A_dist10(ind-1,:)*(1-lw)  ] ) )./ sum(sum([A_dist10(1:ind-2,:);A_dist10(ind-1,:)*(1-lw) ] ))    %.20 ;
  
display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')  
  
ind = min(find((WealthIneq10(:,1))>=.50));

lw = 1 - (.50 - WealthIneq10(ind-1,1) ) / ( WealthIneq10(ind,1) - WealthIneq10(ind-1,1) );

gain_ax1(ind-2,:) ;

dmg = lw*gain_ax1(ind-2,:) + (1-lw)*gain_ax1(ind-1,:);

gain_ax1(ind-1,:) ;

display('Median welfare gain - Transition ')

mg = sum(dmg.*inv_x)
     
display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')  
  
 ind = min(find((WealthIneq10(:,1))>=.99)) ;  
 
 lw = 1 - (.99 - WealthIneq10(ind-1,1) ) / ( WealthIneq10(ind,1) - WealthIneq10(ind-1,1) );
 
 gain_ax1(ind-2,:);
 
 g99 =  lw*gain_ax1(ind-2,:) + (1-lw)*gain_ax1(ind-1,:);
 
 gain_ax1(ind-1,:);
 
display('Welfare gain of the top percentile - Transition ')
   
gain_top1 = sum( sum( [  g99  ;  gain_ax1(ind:na,:) ].*[ (lw)*A_dist10(ind-1,:); A_dist10(ind:na,:)  ] ) ) / sum(  sum([ (lw)*A_dist10(ind-1,:); A_dist10(ind:na,:)  ]))

display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')  

%% Disaggregated welfare gains along productivity dimension

display('Welfare gain of low productivity- Transition ')

gain_L = sum(sum(gain_ax1(:,3).*A_dist10(:,3))) /  inv_x(3)

display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')  

display('Welfare gain of medium productivity- Transition ')

gain_M = sum(sum(gain_ax1(:,2).*A_dist10(:,2))) /  inv_x(2)

display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')  

display('Welfare gain of high productivity- Transition ')

gain_H = sum(sum(gain_ax1(:,1).*A_dist10(:,1))) /  inv_x(1)

display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')  

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% AGGREGATION IS CARRIED OVER THE TERMINAL DISTRIBUTION

else
    
display('Aggregate over terminal distribution: ')
display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')

% Gradual	

gain_ax1  =    100*(    (  ( V_transition*(1-beta)*(1-sigma) + 1 )./( V_0*(1-beta)*(1-sigma) + 1 )   ).^ (1/(1-sigma) )   -   1     )  ;

wegain_ax1  = gain_ax1.*A_dist;

agg_gain1 = sum(sum(wegain_ax1));

agg_gain_EG1  =    100*(  (   (    sum(sum(V_transition.*A_dist))*(1-beta)*(1-sigma) + 1 )./( sum(sum(V_0.*A_dist))*(1-beta)*(1-sigma) + 1 )   ).^ (1/(1-sigma) )   -   1   )  ;

display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')
display('CE_Egalitarian welfare gain from gradual disinflation : ')
agg_gain_EG1
display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')
display('CE_Utilitarian welfare gain from gradual disinflation is: ')
agg_gain1
display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')

%  Disaggregated welfare gains table for transition
 inv_x = [ 0.045471   0.909054   0.045471];

ind = min(find((WealthIneq(:,1))>=.20));

lw = 1 - (.20 - WealthIneq(ind-1,1) ) / ( WealthIneq(ind,1) - WealthIneq(ind-1,1) );
 
gain_ax1(ind-2,:) ;
  
g20 = lw*gain_ax1(ind-2,:) + (1-lw)*gain_ax1(ind-1,:);

gain_ax1(ind-1,:);

display('Welfare gain of the bottom quintile - Transition ')
  
gain_bottom20 = sum(sum( [ gain_ax1(1:ind-2,:); g20  ].*[A_dist(1:ind-2,:);A_dist(ind-1,:)*(1-lw) ] ) )./ sum(sum([A_dist(1:ind-2,:);A_dist(ind-1,:)*(1-lw) ] ))    %.20 ;

display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')  
    
ind = min(find((WealthIneq(:,1))>=.50));

lw = 1 - (.50 - WealthIneq(ind-1,1) ) / ( WealthIneq(ind,1) - WealthIneq(ind-1,1) );

gain_ax1(ind-2,:) ;

dmg = lw*gain_ax1(ind-2,:) + (1-lw)*gain_ax1(ind-1,:);

gain_ax1(ind-1,:) ;

display('Median welfare gain - Transition ')

mg = sum(dmg.*inv_x)
     
display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')  
  
 ind = min(find((WealthIneq(:,1))>=.99)) ;
 
 lw = 1 - (.99 - WealthIneq(ind-1,1) ) / ( WealthIneq(ind,1) - WealthIneq(ind-1,1) );
 
 gain_ax1(ind-2,:);
 
 g99 =  lw*gain_ax1(ind-2,:) + (1-lw)*gain_ax1(ind-1,:);
 
 gain_ax1(ind-1,:);
 
display('Welfare gain of the top percentile - Transition ')
   
gain_top1 = sum( sum( [  g99 ;  gain_ax1(ind:na,:) ].*[ (lw)*A_dist(ind-1,:); A_dist(ind:na,:)  ] ) ) / sum(  sum([ (lw)*A_dist(ind-1,:); A_dist(ind:na,:)  ]))

display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')  

%% Disaggregated welfare gains along productivity dimension

display('Welfare gain of low productivity- Transition ')

gain_L = sum(sum(gain_ax1(:,3).*A_dist(:,3))) /  inv_x(3)

display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')  

display('Welfare gain of medium productivity- Transition ')

gain_M = sum(sum(gain_ax1(:,2).*A_dist(:,2))) /  inv_x(2)

display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')  

display('Welfare gain of high productivity- Transition ')

gain_H = sum(sum(gain_ax1(:,1).*A_dist(:,1))) /  inv_x(1)

display('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')  

end
