subroutine FinInequality
use parameters
implicit none

!! Initial cdf and Lorenz for bonds, money and consumption


open (UNIT=12,FILE='PortfolioIneq10.txt')
do i=1,na*nx+1
READ (UNIT=12,FMT=*)PI_t(i,1,1),PI_t(i,2,1),PI_t(i,3,1),PI_t(i,4,1),PI_t(i,5,1),PI_t(i,6,1),PI_t(i,7,1),PI_t(i,8,1)
end do
close(UNIT=12)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!BONDS
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

bpdf_sorted_t = 0.                              ! Probability density of the sorted bond grid

!!!!-------------------------------------------------------------------
!!!!    Cumulative distribution and lorenz curve for bonds FOR PERIOD 1
!!!!-------------------------------------------------------------------

b_cdf_t(:,1) = PI_t(:,1,1)

b_lorenz_t(:,1) = PI_t(:,2,1)

b_sorted_t(:,1) = reshape(b_policy_0,(/na*nx/))

call quicksort(b_sorted_t(:,1),size(b_sorted_t(:,1)))

do ii = 1,na*nx

        if (ii==1 .or. b_sorted_t(ii,1) /= b_sorted_t(ii-1,1) ) then

            do i=1,na
                do j=1,nx
                    if ( (b_sorted_t(ii,1)) == b_policy_0(i,j)) then
                        bpdf_sorted_t(ii,1) = bpdf_sorted_t(ii,1) + invasset_0(i,j)
                    end if
                end do
            end do

        end if
end do

n=100
gini_b_t = 0.

do i=2,na*nx+1

gini_b_t(1,1) = gini_b_t(1,1) + (b_cdf_t(i,1)-b_cdf_t(i-1,1))*b_lorenz_t(i-1,1)

    do kk = 1,n-1

gini_b_t(1,1) = gini_b_t(1,1) + ( (n-kk)*(b_cdf_t(i,1) - b_cdf_t(i-1,1))/n ) * ( (b_lorenz_t(i,1)-b_lorenz_t(i-1,1))/n )

    end do      ! Approximating the area under the Lorenz curve

end do

gini_b_t(1,1) = 2.*(0.5-gini_b_t(1,1))

!!!!-------------------------------------------------------------------
!!!!  Cumulative distribution and lorenz curve for PERIODS 2 AND ON
!!!!-------------------------------------------------------------------

DO t=2,T4

b_sorted_t(:,t) = reshape(b_policy_t(:,:,t-1),(/na*nx/))

call quicksort(b_sorted_t(:,t),size(b_sorted_t(:,t)))

b_cdf_t(1,t) = 0.

b_lorenz_t(1,t) = 0.

!!!!-----------------------------------------------------
!!!! Cumulative distribution and lorenz curve for bonds
!!!!-----------------------------------------------------

do ii = 1,na*nx

        if (ii>1 .and. b_sorted_t(ii,t) == b_sorted_t(ii-1,t) ) then

        b_cdf_t(ii+1,t) = b_cdf_t(ii,t)
        b_lorenz_t(ii+1,t) = b_lorenz_t(ii,t)

        else

            do i=1,na
                do j=1,nx
                    if (  b_sorted_t(ii,t) == b_policy_t(i,j,t-1) ) then
                        bpdf_sorted_t(ii,t) = bpdf_sorted_t(ii,t) + assetdist(i,j,t-1)
                    end if
                end do
            end do

        b_cdf_t(ii+1,t) = b_cdf_t(ii,t) + bpdf_sorted_t(ii,t)
        b_lorenz_t(ii+1,t) = b_lorenz_t(ii,t) + ( b_sorted_t(ii,t) - minval(b_sorted_t(:,t)))*bpdf_sorted_t(ii,t)      ! We use the normalized bond grid points while computing the Lorenz curve

        end if
end do

b_lorenz_t(:,t) = b_lorenz_t(:,t)/sum( ( b_sorted_t(:,t)-minval(b_sorted_t(:,t)) )*bpdf_sorted_t(:,t) )            ! We use the aggregate normalized bond while computing the Lorenz curve

!!!!------------------------------------
!!!! Gini coefficient of bonds
!!!!------------------------------------

n=100
do i=2,na*nx+1

gini_b_t(1,t) = gini_b_t(1,t) + (b_cdf_t(i,t)-b_cdf_t(i-1,t))*b_lorenz_t(i-1,t)

    do kk = 1,n-1

gini_b_t(1,t) = gini_b_t(1,t) + ( (n-kk)*(b_cdf_t(i,t) - b_cdf_t(i-1,t))/n ) * ( (b_lorenz_t(i,t)-b_lorenz_t(i-1,t))/n )

    end do      ! Approximating the area under the Lorenz curve

end do

gini_b_t(1,t) = 2.*(0.5-gini_b_t(1,t))

END DO

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!MONEY
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

mpdf_sorted_t = 0.                              ! Probability density of the sorted money grid

!!!!-------------------------------------------------------------------
!!!! Cumulative distribution and lorenz curve for money FOR PERIOD 1
!!!!-------------------------------------------------------------------

m_cdf_t(:,1) = PI_t(:,3,1)

m_lorenz_t(:,1) = PI_t(:,4,1)

m_sorted_t(:,1) = reshape(m_policy_0,(/na*nx/))

call quicksort(m_sorted_t(:,1),size(m_sorted_t(:,1)))

do ii = 1,na*nx

        if (ii==1 .or. m_sorted_t(ii,1) /= m_sorted_t(ii-1,1) ) then

            do i=1,na
                do j=1,nx
                    if ( (m_sorted_t(ii,1)) == m_policy_0(i,j)) then
                        mpdf_sorted_t(ii,1) = mpdf_sorted_t(ii,1) + invasset_0(i,j)
                    end if
                end do
            end do

        end if
end do

!! Gini for PERIOD 1

n=100
gini_m_t = 0.

do i=2,na*nx+1

gini_m_t(1,1) = gini_m_t(1,1) + (m_cdf_t(i,1)-m_cdf_t(i-1,1))*m_lorenz_t(i-1,1)

    do kk = 1,n-1

gini_m_t(1,1) = gini_m_t(1,1) + ( (n-kk)*(m_cdf_t(i,1) - m_cdf_t(i-1,1))/n ) * ( (m_lorenz_t(i,1)-m_lorenz_t(i-1,1))/n )

    end do      ! Approximating the area under the Lorenz curve

end do

gini_m_t(1,1) = 2.*(0.5-gini_m_t(1,1))

!!!!----------------------------------------------------------------------
!!!! Cumulative distribution and lorenz curve for money PERIODS 2 AND ON
!!!!----------------------------------------------------------------------

DO t=2,T4

m_sorted_t(:,t) = reshape(m_policy_t(:,:,t-1),(/na*nx/))

call quicksort(m_sorted_t(:,t),size(m_sorted_t(:,t)))

m_cdf_t(1,t) = 0.

m_lorenz_t(1,t) = 0.

!!!!-----------------------------------------------------
!!!! Cumulative distribution and lorenz curve for money
!!!!-----------------------------------------------------

do ii = 1,na*nx

        if (ii>1 .and. m_sorted_t(ii,t) == m_sorted_t(ii-1,t) ) then

        m_cdf_t(ii+1,t) = m_cdf_t(ii,t)
        m_lorenz_t(ii+1,t) = m_lorenz_t(ii,t)

        else

            do i=1,na
                do j=1,nx
                    if (  m_sorted_t(ii,t) == m_policy_t(i,j,t-1) ) then
                        mpdf_sorted_t(ii,t) = mpdf_sorted_t(ii,t) + assetdist(i,j,t-1)
                    end if
                end do
            end do

        m_cdf_t(ii+1,t) = m_cdf_t(ii,t) + mpdf_sorted_t(ii,t)
        m_lorenz_t(ii+1,t) = m_lorenz_t(ii,t) + ( m_sorted_t(ii,t) - minval(m_sorted_t(:,t)))*mpdf_sorted_t(ii,t)      ! We use the normalized bond grid points while computing the Lorenz curve

        end if
end do

m_lorenz_t(:,t) = m_lorenz_t(:,t)/sum( ( m_sorted_t(:,t)-minval(m_sorted_t(:,t)) )*mpdf_sorted_t(:,t) )            ! We use the aggregate normalized bond while computing the Lorenz curve

!!!!------------------------------------
!!!! Gini coefficient of money
!!!!------------------------------------

n=100
do i=2,na*nx+1

gini_m_t(1,t) = gini_m_t(1,t) + (m_cdf_t(i,t)-m_cdf_t(i-1,t))*m_lorenz_t(i-1,t)

    do kk = 1,n-1

gini_m_t(1,t) = gini_m_t(1,t) + ( (n-kk)*(m_cdf_t(i,t) - m_cdf_t(i-1,t))/n ) * ( (m_lorenz_t(i,t)-m_lorenz_t(i-1,t))/n )

    end do      ! Approximating the area under the Lorenz curve

end do

gini_m_t(1,t) = 2.*(0.5-gini_m_t(1,t))

END DO

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!FINANCIAL ASSETS
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

finpdf_sorted_t = 0.                              ! Probability density of the sorted money grid

!!!!-------------------------------------------------------------------
!!!! Cumulative distribution and lorenz curve for money FOR PERIOD 1
!!!!-------------------------------------------------------------------

fin_cdf_t(:,1) = PI_t(:,7,1)

fin_lorenz_t(:,1) = PI_t(:,8,1)

fin_sorted_t(:,1) = reshape(b_policy_0 + m_policy_0,(/na*nx/))

call quicksort(fin_sorted_t(:,1),size(fin_sorted_t(:,1)))

do ii = 1,na*nx

        if (ii==1 .or. fin_sorted_t(ii,1) /= fin_sorted_t(ii-1,1) ) then

            do i=1,na
                do j=1,nx
                    if ( (fin_sorted_t(ii,1)) == (b_policy_0(i,j) + m_policy_0(i,j)) ) then
                        finpdf_sorted_t(ii,1) = finpdf_sorted_t(ii,1) + invasset_0(i,j)
                    end if
                end do
            end do

        end if
end do

!! Gini for PERIOD 1

n=100
gini_fin_t = 0.

do i=2,na*nx+1

gini_fin_t(1,1) = gini_fin_t(1,1) + (fin_cdf_t(i,1)-fin_cdf_t(i-1,1))*fin_lorenz_t(i-1,1)

    do kk = 1,n-1

gini_fin_t(1,1) = gini_fin_t(1,1) + ( (n-kk)*(fin_cdf_t(i,1) - fin_cdf_t(i-1,1))/n ) * ( (fin_lorenz_t(i,1)-fin_lorenz_t(i-1,1))/n )

    end do      ! Approximating the area under the Lorenz curve

end do

gini_fin_t(1,1) = 2.*(0.5-gini_fin_t(1,1))

!!!!----------------------------------------------------------------------
!!!! Cumulative distribution and lorenz curve for financial assets PERIODS 2 AND ON
!!!!----------------------------------------------------------------------

DO t=2,T4

fin_sorted_t(:,t) = reshape( b_policy_t(:,:,t-1) + m_policy_t(:,:,t-1) ,(/na*nx/))

call quicksort(fin_sorted_t(:,t),size(fin_sorted_t(:,t)))

fin_cdf_t(1,t) = 0.

fin_lorenz_t(1,t) = 0.

!!!!-----------------------------------------------------
!!!! Cumulative distribution and lorenz curve for financial assets
!!!!-----------------------------------------------------

do ii = 1,na*nx

        if (ii>1 .and. fin_sorted_t(ii,t) == fin_sorted_t(ii-1,t) ) then

        fin_cdf_t(ii+1,t) = fin_cdf_t(ii,t)
        fin_lorenz_t(ii+1,t) = fin_lorenz_t(ii,t)

        else

            do i=1,na
                do j=1,nx
                    if (  fin_sorted_t(ii,t) == ( b_policy_t(i,j,t-1) + m_policy_t(i,j,t-1) )  ) then
                        finpdf_sorted_t(ii,t) = finpdf_sorted_t(ii,t) + assetdist(i,j,t-1)
                    end if
                end do
            end do

        fin_cdf_t(ii+1,t) = fin_cdf_t(ii,t) + finpdf_sorted_t(ii,t)
        fin_lorenz_t(ii+1,t) = fin_lorenz_t(ii,t) + ( fin_sorted_t(ii,t) - minval(fin_sorted_t(:,t)))*finpdf_sorted_t(ii,t)      ! We use the normalized bond grid points while computing the Lorenz curve

        end if
end do

fin_lorenz_t(:,t) = fin_lorenz_t(:,t)/sum( ( fin_sorted_t(:,t)-minval(fin_sorted_t(:,t)) )*finpdf_sorted_t(:,t) )            ! We use the aggregate normalized bond while computing the Lorenz curve

!!!!------------------------------------
!!!! Gini coefficient of financial assets
!!!!------------------------------------

n=100
do i=2,na*nx+1

gini_fin_t(1,t) = gini_fin_t(1,t) + (fin_cdf_t(i,t)-fin_cdf_t(i-1,t))*fin_lorenz_t(i-1,t)

    do kk = 1,n-1

gini_fin_t(1,t) = gini_fin_t(1,t) + ( (n-kk)*(fin_cdf_t(i,t) - fin_cdf_t(i-1,t))/n ) * ( (fin_lorenz_t(i,t)-fin_lorenz_t(i-1,t))/n )

    end do      ! Approximating the area under the Lorenz curve

end do

gini_fin_t(1,t) = 2.*(0.5-gini_fin_t(1,t))

END DO


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!CONSUMPTION
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

cpdf_sorted_t = 0.                              ! Probability density of the sorted consumption grid

!!!!-------------------------------------------------------------------------------
!!!! Cumulative distribution and lorenz curve of consumption for PERIODS 1 AND ON
!!!! (taking into account the initial impact of transition)
!!!!-------------------------------------------------------------------------------

DO t=1,T4

c_sorted_t(:,t) = reshape(c_policy_t(:,:,t),(/na*nx/))

call quicksort(c_sorted_t(:,t),size(c_sorted_t(:,t)))

c_cdf_t(1,t) = 0.

c_lorenz_t(1,t) = 0.

!!!!-----------------------------------------------------------
!!!! Cumulative distribution and lorenz curve for consumption
!!!!-----------------------------------------------------------

do ii = 1,na*nx

        if (ii>1 .and. c_sorted_t(ii,t) == c_sorted_t(ii-1,t) ) then

        c_cdf_t(ii+1,t) = c_cdf_t(ii,t)
        c_lorenz_t(ii+1,t) = c_lorenz_t(ii,t)

        else

            do i=1,na
                do j=1,nx
                    if (  c_sorted_t(ii,t) == c_policy_t(i,j,t) ) then
                        cpdf_sorted_t(ii,t) = cpdf_sorted_t(ii,t) + assetdist(i,j,t)
                    end if
                end do
            end do

        c_cdf_t(ii+1,t) = c_cdf_t(ii,t) + cpdf_sorted_t(ii,t)
        c_lorenz_t(ii+1,t) = c_lorenz_t(ii,t) + ( c_sorted_t(ii,t) - minval(c_sorted_t(:,t)))*cpdf_sorted_t(ii,t)      ! We use the normalized consumption grid points while computing the Lorenz curve

        end if
end do

c_lorenz_t(:,t) = c_lorenz_t(:,t)/sum( ( c_sorted_t(:,t)-minval(c_sorted_t(:,t)) )*cpdf_sorted_t(:,t) )            ! We use the aggregate normalized consumption while computing the Lorenz curve

!!!!------------------------------------
!!!! Gini coefficient of consumption
!!!!------------------------------------

n=100
do i=2,na*nx+1

gini_c_t(1,t) = gini_c_t(1,t) + (c_cdf_t(i,t)-c_cdf_t(i-1,t))*c_lorenz_t(i-1,t)

    do kk = 1,n-1

gini_c_t(1,t) = gini_c_t(1,t) + ( (n-kk)*(c_cdf_t(i,t) - c_cdf_t(i-1,t))/n ) * ( (c_lorenz_t(i,t)-c_lorenz_t(i-1,t))/n )

    end do      ! Approximating the area under the Lorenz curve

end do

gini_c_t(1,t) = 2.*(0.5-gini_c_t(1,t))

END DO

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!INCOME
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!! Income in period 1 (taking into account the initial conditions)

ypdf_t = 0.

do i=1,na
    do j=1,nx

y_disp_t(i,j,1) = (1-tau_h_t(1,1))*w_t(1,1)*x(j,1)*h_policy_t(i,j,1) + &

                  (1-tau_k_t(1,1))*((K_0**alpha*L_0**(1.-alpha))**theta - delta*K_0 &

                  - w_t(1,1)*L_0) + (R_star_0-1)*B_0 &   ! Disposable income at the idiosyncratic level

                  - ( m_policy_t(i,j,1) - M_0/(1+inf_t(1,1)) ) + tau_t(1,1)

        do jj=1,nx
            ypdf_t(i,j,1) = ypdf_t(i,j,1) + invx(j,1)*assetdist(i,jj,1)
        end do

    end do
end do

AY_t(1,1) = sum(y_disp_t(:,:,1)*ypdf_t(:,:,1))

y_sorted_t(:,1) = reshape(y_disp_t(:,:,1),(/na*nx/))

call quicksort(y_sorted_t(:,1),size(y_sorted_t(:,1)))

ycdf_t = 0.

ylorenz_t = 0.

ypdf_sorted_t = 0.

!!!!-----------------------------------------------------
!!!! Cumulative distribution and lorenz curve for income
!!!!-----------------------------------------------------

do kk = 1,na*nx

        if (kk>1 .and. y_sorted_t(kk,1) == y_sorted_t(kk-1,1) ) then

        ycdf_t(kk+1,1) = ycdf_t(kk,1)
        ylorenz_t(kk+1,1) = ylorenz_t(kk,1)

        else

            do i=1,na
                do j=1,nx
                    if (y_sorted_t(kk,1) == y_disp_t(i,j,1)) then
                        ypdf_sorted_t(kk,1) = ypdf_sorted_t(kk,1) + ypdf_t(i,j,1)

                    end if
                end do
            end do

        ycdf_t(kk+1,1) = ycdf_t(kk,1) + ypdf_sorted_t(kk,1)
        ylorenz_t(kk+1,1) = ylorenz_t(kk,1) + y_sorted_t(kk,1)*ypdf_sorted_t(kk,1)

        end if
end do

ylorenz_t(:,1) = ylorenz_t(:,1)/AY_t(1,1)

!!!!--------------------------------
!!!! Gini coefficient of income
!!!!--------------------------------

n=100
gini_y_t(1,1) = 0.
do i=2,na*nx+1

gini_y_t(1,1) = gini_y_t(1,1) + (ycdf_t(i,1)-ycdf_t(i-1,1))*ylorenz_t(i-1,1)

    do kk = 1,n-1

gini_y_t(1,1) = gini_y_t(1,1) + ( (n-kk)*(ycdf_t(i,1) - ycdf_t(i-1,1))/n ) * ( (ylorenz_t(i,1)-ylorenz_t(i-1,1))/n )

    end do      ! Approximating the area under the Lorenz curve

end do

gini_y_t(1,1) = 2.*(0.5-gini_y_t(1,1))

!!!!--------------------------------------------------------------------------
!!!! Cumulative distribution and lorenz curve of income for PERIODS 1 AND ON
!!!! (taking into account the initial conditions)
!!!!--------------------------------------------------------------------------

DO t=2,T4

do i=1,na
    do j=1,nx

y_disp_t(i,j,t) = (1-tau_h_t(1,t))*w_t(1,t)*x(j,1)*h_policy_t(i,j,t) + &    ! Disposable income at the idiosyncratic level

                  (1-tau_k_t(1,t))*((K_a_x_t(1,t-1)**alpha*L_a_x_t(1,t-1)**(1.-alpha))**theta - delta*K_a_x_t(1,t-1) &

                  - w_t(1,t)*L_a_x_t(1,t-1)) + (R_star_t(1,t-1)-1)*b_policy_t(i,j,t-1) &

                  - ( m_policy_t(i,j,t) - m_policy_t(i,j,t-1)/(1+inf_t(1,t)) ) + tau_t(1,t)

        do jj=1,nx
            ypdf_t(i,j,t) = ypdf_t(i,j,t) + invx(j,1)*assetdist(i,jj,t)
        end do

    end do
end do

AY_t(1,t) = sum(y_disp_t(:,:,t)*ypdf_t(:,:,t))

y_sorted_t(:,t) = reshape(y_disp_t(:,:,t),(/na*nx/))

call quicksort(y_sorted_t(:,t),size(y_sorted_t(:,t)))

!!!!-----------------------------------------------------
!!!! Cumulative distribution and lorenz curve for income
!!!!-----------------------------------------------------

do kk = 1,na*nx

        if (kk>1 .and. y_sorted_t(kk,t) == y_sorted_t(kk-1,t) ) then

        ycdf_t(kk+1,t) = ycdf_t(kk,t)
        ylorenz_t(kk+1,t) = ylorenz_t(kk,t)

        else

            do i=1,na
                do j=1,nx
                    if (y_sorted_t(kk,t) == y_disp_t(i,j,t)) then
                        ypdf_sorted_t(kk,t) = ypdf_sorted_t(kk,t) + ypdf_t(i,j,t)

                    end if
                end do
            end do

        ycdf_t(kk+1,t) = ycdf_t(kk,t) + ypdf_sorted_t(kk,t)
        ylorenz_t(kk+1,t) = ylorenz_t(kk,t) + y_sorted_t(kk,t)*ypdf_sorted_t(kk,t)

        end if
end do

ylorenz_t(:,t) = ylorenz_t(:,t)/AY_t(1,t)

!!!!--------------------------------
!!!! Gini coefficient of income
!!!!--------------------------------

n=100
gini_y_t(1,t) = 0.
do i=2,na*nx+1

gini_y_t(1,t) = gini_y_t(1,t) + (ycdf_t(i,t)-ycdf_t(i-1,t))*ylorenz_t(i-1,t)

    do kk = 1,n-1

gini_y_t(1,t) = gini_y_t(1,t) + ( (n-kk)*(ycdf_t(i,t) - ycdf_t(i-1,t))/n ) * ( (ylorenz_t(i,t)-ylorenz_t(i-1,t))/n )

    end do      ! Approximating the area under the Lorenz curve

end do

gini_y_t(1,t) = 2.*(0.5-gini_y_t(1,t))

END DO

end subroutine FinInequality
