! @c Enes Sunel
! Jan 2015, Central Bank of Turkey
! This subprogram generates the output files as '.txt'.

subroutine output

use parameters
implicit none

!!-------------------------------------------------------------------------------

open (UNIT=12,FILE='V_transition.txt',STATUS='replace')

do i=1,na
WRITE(UNIT=12,FMT=*)Vfuture(i,1),Vfuture(i,2),Vfuture(i,3)
end do

!!-------------------------------------------------------------------------------

open (UNIT=13,FILE='V_0.txt',STATUS='replace')

do i=1,na
WRITE(UNIT=13,FMT=*)V_0(i,1),V_0(i,2),V_0(i,3)
end do

!!-------------------------------------------------------------------------------

open (UNIT=1,FILE='Macro_Variables.txt',STATUS='replace')

do t=1,T4
WRITE(UNIT=1,FMT=*)Y_t(1,t),tau_t(1,t),w_t(1,t),C_t(1,t),G_t(1,t),H_t(1,t),B_t(1,t)&
,K_t(1,t),L_t(1,t),M_t(1,t),Tr_t(1,t),inf_t(1,t),ED_t(1,t),PS_t(1,t),vel_t(1,t),I_t(1,t),SE_t(1,t)!,bpdf_sortedFin(1,t)
end do

!!-------------------------------------------------------------------------------

open (UNIT=2,FILE='Initial.txt',STATUS='replace')

WRITE(UNIT=2,FMT=*)Y_0,tau_0,C_0,Tr_0,B_0,M_0,gstar_0,wstar_0,H_0,K_0

!!-------------------------------------------------------------------------------

open (UNIT=4,FILE='Terminal.txt',STATUS='replace')

WRITE(UNIT=4,FMT=*)Y_T4,tau_T4,C_T4,Tr_T4,B_T4,M_T4,gstar_T4,wstar_T4,H_T4,K_T4

!! Columnizes decision rules and distributions to work on them in Matlab

Bt_prime = reshape(b_policy_t,(/na*nx*T4/))

Ct_prime = reshape(c_policy_t,(/na*nx*T4/))

Ht_prime = reshape(h_policy_t,(/na*nx*T4/))

Mt_prime = reshape(m_policy_t,(/na*nx*T4/))

At_prime = reshape(a_policy_t,(/na*nx*T4/))

At_dist = reshape(assetdist,(/na*nx*T4/))

!!-------------------------------------------------------------------------------

open (UNIT=3,FILE='Decis_Dist.txt',STATUS='replace')

do i=1,na*nx*T4
WRITE(UNIT=3,FMT=*)Bt_prime(i),Ct_prime(i),Ht_prime(i),Mt_prime(i),At_prime(i),&
At_dist(i)
end do

!!-------------------------------------------------------------------------------

open (UNIT=14,FILE='Gini.txt',STATUS='replace')

do t=1,T4
WRITE(UNIT=14,FMT=*)gini_b_t(1,t),gini_m_t(1,t),gini_c_t(1,t),gini_y_t(1,t),gini_fin_t(1,t)
end do

end subroutine output
