! @c Enes Sunel
! May 2014, Central Bank of Turkey
! Solution of the stationary equilibrium of Sunel (2014)
! This is a small open production economy with incomplete markets and idiosyncratic uncertainty
! You can use this code with any purpose at your own risk.

program main
use parameters
implicit none

call Initialize

print*,'-------------------------------------------------------------------------------'
print*,'x_bar :',x_bar
print*,'---------------------------------------------------------------------'
print*,'invx :',invx
print*,'---------------------------------------------------------------------'
print*,'Standard deviation of the productivity process is: ', sqrt(var_x)
print*,'-------------------------------------------------------------------------------'
print*,'alpha :',alpha
print*,'---------------------------------------------------------------------'
print*,'theta :',theta
print*,'---------------------------------------------------------------------'
print*,'sigma :',sigma
print*,'---------------------------------------------------------------------'
print*,'beta :',beta
print*,'---------------------------------------------------------------------'
print*,'R_star :',R_star
print*,'---------------------------------------------------------------------'
print*,'delta :',delta
print*,'---------------------------------------------------------------------'
print*,'psi :',psi
print*,'---------------------------------------------------------------------'
print*,'eta :',eta
print*,'---------------------------------------------------------------------'
print*,'varrho :',varrho
print*,'---------------------------------------------------------------------'
print*,'phi :',phi
print*,'---------------------------------------------------------------------'
print*,'gama :',gama
print*,'---------------------------------------------------------------------'
print*,'Inflation: ',inf
print*,'---------------------------------------------------------------------'
print*,'w:',w
print*,'---------------------------------------------------------------------'
print*,'tau_h: ',tau_h,'tau_k: ',tau_k
print*,'---------------------------------------------------------------------'
print*,'G/Y: ',G/Y,'Y: ',Y
print*,'---------------------------------------------------------------------'
print*,'AUB :',aub,'BUB :',bub
print*,'---------------------------------------------------------------------'
print*,'AlB :',alb,'BlB :',blb
print*,'---------------------------------------------------------------------'
print*,'SIZE OF a:',na,'SIZE OF b:',nb
print*,'---------------------------------------------------------------------'

PS = 10.

H_L = 10.

tau_diff = 10.

print*,'KONTROL',inca


if (inf == .02) then

open (UNIT=7,FILE='Value.txt')             ! Reads the stored value function from the previous approximation

do i=1,na
Read (UNIT=7,FMT=*)V(i,1),V(i,2),V(i,3)
end do
close(UNIT=7)

open (UNIT=8,FILE='Transfers.txt')         ! Reads the stored transfers from the previous approximation

do i=1,na
Read (UNIT=8,FMT=*)tau(i,1),tau(i,2),tau(i,3)
end do
close (UNIT=8)

elseif (inf == .14) then

open (UNIT=7,FILE='Value10.txt')             ! Reads the stored value function from the previous approximation

do i=1,na
Read (UNIT=7,FMT=*)V(i,1),V(i,2),V(i,3)
end do
close(UNIT=7)

open (UNIT=8,FILE='Transfers10.txt')         ! Reads the stored transfers from the previous approximation

do i=1,na
Read (UNIT=8,FMT=*)tau(i,1),tau(i,2),tau(i,3)
end do
close (UNIT=8)

end if

!!!!!----------------------------------------------------------------------
DO  !n =1,10 !LOOPING OVER EQUILIBRIUM TRANSFERS AND CAPITAL-LABOR RATIO
!!!!!----------------------------------------------------------------------

     if ( max(abs(PS),abs(H_L)) < 1.e-04  .and. maxval(abs(tau_diff)) < 1.e-04  ) exit

call VFI

call Distribution

!!!!!---------------------------------------------------------------
END DO      ! LOOPING OVER EQUILIBRIUM ENDS
!!!!!---------------------------------------------------------------

call Inequality                  ! Inequality measures


call DTIME(VALUES, TIME)

print*,'----------------------------------------------------------------------------'
print*,'alpha :',alpha
print*,'---------------------------------------------------------------------'
print*,'theta :',theta
print*,'---------------------------------------------------------------------'
print*,'sigma :',sigma
print*,'---------------------------------------------------------------------'
print*,'beta :',beta
print*,'---------------------------------------------------------------------'
print*,'R_star :',R_star
print*,'---------------------------------------------------------------------'
print*,'delta :',delta
print*,'---------------------------------------------------------------------'
print*,'psi :',psi
print*,'---------------------------------------------------------------------'
print*,'eta :',eta
print*,'---------------------------------------------------------------------'
print*,'varrho :',varrho
print*,'---------------------------------------------------------------------'
print*,'phi :',phi
print*,'---------------------------------------------------------------------'
print*,'gama :',gama
print*,'---------------------------------------------------------------------'
print*,'Inflation: ',inf
print*,'---------------------------------------------------------------------'
print*,'Tau: ',sum(tau*invasset)
print*,'---------------------------------------------------------------------'
print*,'tau_h: ',tau_h,'tau_k: ',tau_k
print*,'---------------------------------------------------------------------'
print*,'G/Y: ',G/Y,'Y: ',Y,'C/M: ',C/M,'C: ',C,'M: ',M
print*,'---------------------------------------------------------------------'
print*,'AUB :',aub,'BUB :',bub
print*,'---------------------------------------------------------------------'
print*,'AlB :',alb,'BlB :',blb
print*,'---------------------------------------------------------------------'
print*,'SIZE OF a:',na,'SIZE OF b:',nb,'SIZE OF m:',nm
print*,'---------------------------------------------------------------------'
print*,'The computation took',time,'seconds!',time/60,'minutes!'
print*,'--------------------------------------------------------'
print*,'K/L: ',K/L,'H: ',H,'L_a_x: ',L_a_x,'K/Y: ',K/Y,'Tau: ',sum(tau*invasset),'w: ',w
print*,'---------------------------------------------------------------------'
print*,'C/Y: ',C/Y,'TR/Y: ',TR/Y,'I/Y: ',(delta*K)/Y,'G/Y: ',G/Y,'NX/Y: ',(1-R_star)*B/Y,'Tau/Y: ',&
sum(tau*invasset)/Y,'SE/Y: ',inf*M/(Y*(1.+inf)),'B/(B+M): ',B/(B+M)
print*,'----------------------------------------------------------------------------------------------------------'

call output

end program main


