clear all
close all
clc

%% Aggregates and Value Functions

load 'Macro_Variables.txt'
load 'A_prime.txt' 
load 'V_0.txt' 
load 'V_transition.txt' 
load 'A_dist10.txt'
load 'A_dist.txt'
load 'Initial.txt'
load 'Terminal.txt'
load 'Wealth.txt'
load 'Aggregates10.txt'
load 'Aggregates.txt'
load 'WealthIneq10.txt'
load 'WealthIneq.txt'
load 'Value10.txt'
load 'H_prime10.txt'
load 'Value.txt'
load 'H_prime.txt'

%% Parameters

nx = 3;
na = length(Wealth);
R_star = 1.0158;
t4 = length(Macro_Variables);
t3 = t4;
delta = 0.0375;
sigma = 2.;
beta = 0.98137;
gama = 1.85;
eta = 4.5;
phi = 0.0052;
psi = 70;
inf  = [-.005 .0  .02  .05  .07  .14 .20 .30 .50];

% Initial Aggregates

y_0 = Initial(1);
tau_0= Initial(2);
c_0  = Initial(3);
tr_0 = Initial(4);
b_0  = Initial(5);
m_0 = Initial(6);
G_0 = Initial(7);
w_0 = Initial(8);
h_0 = Initial(9);
k_0 = Initial(10);
inv_0 = delta*k_0;
se_0 = .14*m_0/(1+.14);
vel_0 = c_0/m_0;
tr_y_0 = tr_0/y_0;
se_y_0 = se_0/y_0;
port_0 = b_0/(b_0+m_0);
tau_y_0 = tau_0/y_0;
c_y_0 = c_0/y_0;
inv_y_0 = inv_0/y_0;
nx_y_0 = (1-R_star)*b_0/y_0 ;

% Terminal Aggregates

y_t4 = Terminal(1);
tau_t4= Terminal(2);
c_t4  = Terminal(3);
tr_t4 = Terminal(4);
b_t4  = Terminal(5);
m_t4 = Terminal(6);
G_t4 = Terminal(7);
w_t4 = Initial(8);
h_t4 = Terminal(9);
k_t4 = Terminal(10);
vel_t4 = c_t4/m_t4;

%% AGGREGATES ALONG THE TRANSITION PATH FROM 10% INFLATION TO 2% INFLATION

y_t = Macro_Variables(:,1);
tau_t = Macro_Variables(:,2);
w_t = Macro_Variables(:,3);
c_t = Macro_Variables(:,4);
g_t = Macro_Variables(:,5);
h_t  = Macro_Variables(:,6);
b_t = Macro_Variables(:,7);
k_t = Macro_Variables(:,8);
m_t = Macro_Variables(:,10);
tr_t = Macro_Variables(:,11);
inf_t = Macro_Variables(:,12);
se_t(1) = m_t(1)  -  m_0/(1+.14);
se_t(2:t4) = m_t(2:t4) - m_t(1:t4-1)./(1+inf_t(1:t4-1));
se_t = se_t';
vel_t = c_t./m_t;
port_t = b_t./(b_t+m_t);
nx_y = [ (b_t(1)  - R_star* b_0)/y_0    ;    [b_t(2:t4) - R_star*b_t(1:t4-1) ]./y_t(1:t4-1) ];
inv_y = [ (k_t(1)-(1-delta)*k_0)/y_0  ;  [ (k_t(2:t4) - (1-delta)*k_t(1:t4-1))]./y_t(1:t4-1)     ]  ;
ca_y = [ (b_t(1)  -  b_0)/y_0;  [b_t(2:t4) - b_t(1:t4-1) ]./y_t(1:t4-1);  0   ];
c_y = c_t./y_t;
tau_y = tau_t./y_t;
b_y = b_t./y_t;
m_y = m_t./y_t;
tr_y = tr_t./y_t;
g_y = g_t./y_t;
se_y = se_t./y_t;
S = length([tau_0*ones(20,1); tau_y]);
X = [-4.75:.25:t4/4]';

run welfare

