! This subprogram generates the output files as '.txt'.
! Central Bank of Turkey, January 2015
subroutine Output

use parameters
implicit none

if (inf == 0.02) then

open (UNIT=4,FILE='Wealth.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=4,FMT=*)asset(i,1),a_policy(i,1),a_policy(i,2),a_policy(i,3),sum(invasset(i,:))
end do

open (UNIT=1,FILE='A_prime.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=1,FMT=*)a_policy(i,1),a_policy(i,2),a_policy(i,3)
end do

open (UNIT=1,FILE='B_prime.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=1,FMT=*)b_policy(i,1),b_policy(i,2),b_policy(i,3)
end do

open (UNIT=2,FILE='K_prime.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=2,FMT=*)K_a_x,K_a_x,K_a_x
end do

open (UNIT=2,FILE='L_prime.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=2,FMT=*)L_a_x,L_a_x,L_a_x
end do

open (UNIT=3,FILE='M_prime.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=3,FMT=*)m_policy(i,1),m_policy(i,2),m_policy(i,3)
end do

open (UNIT=5,FILE='C_prime.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=5,FMT=*)c_policy(i,1),c_policy(i,2),c_policy(i,3)
end do

open (UNIT=6,FILE='Kappa_prime.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=6,FMT=*)kap_policy(i,1),kap_policy(i,2),kap_policy(i,3)
end do

open (UNIT=6,FILE='H_prime.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=6,FMT=*)h_policy(i,1),h_policy(i,2),h_policy(i,3)
end do

open (UNIT=7,FILE='Value.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=7,FMT=*)V(i,1),V(i,2),V(i,3)
end do

open (UNIT=8,FILE='y.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=8,FMT=*)y_disp(i,1),y_disp(i,2),y_disp(i,3)
end do

open (UNIT=9,FILE='A_dist.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=9,FMT=*)invasset(i,1),invasset(i,2),invasset(i,3)
end do

open (UNIT=10,FILE='WealthIneq.txt',STATUS='replace')
do i=1,na+1
WRITE(UNIT=10,FMT=*)acdf(i,1),alorenz(i,1)
end do

open (UNIT=11,FILE='IncomeIneq.txt',STATUS='replace')
do i=1,na*nx +1
WRITE(UNIT=11,FMT=*)ycdf(i,1),ylorenz(i,1)
end do

open (UNIT=12,FILE='PortfolioIneq.txt',STATUS='replace')
do i=1,na*nx+1
WRITE(UNIT=12,FMT=*)b_cdf(i,1),b_lorenz(i,1),m_cdf(i,1),m_lorenz(i,1),c_cdf(i,1),c_lorenz(i,1),fin_cdf(i,1),fin_lorenz(i,1)
end do

open (UNIT=13,FILE='Deposits.txt',STATUS='replace')
do i=1,na*nx
WRITE(UNIT=13,FMT=*)fin_sorted(i),finpdf_sorted(i)
end do

open (UNIT=13,FILE='Bonds.txt',STATUS='replace')
do i=1,na*nx
WRITE(UNIT=13,FMT=*)b_sorted(i),bpdf_sorted(i)
end do

open (UNIT=14,FILE='Money.txt',STATUS='replace')
do i=1,na*nx
WRITE(UNIT=14,FMT=*)m_sorted(i),mpdf_sorted(i)
end do

open (UNIT=15,FILE='Income.txt',STATUS='replace')
do i=1,na*nx
WRITE(UNIT=15,FMT=*)y_sorted(i),ypdf_sorted(i)!,earn_inc(i),asset_inc(i),trans_inc(i)
end do

open (UNIT=16,FILE='Consumption.txt',STATUS='replace')
do i=1,na*nx
WRITE(UNIT=16,FMT=*)c_sorted(i),cpdf_sorted(i)
end do

open (UNIT=17,FILE='PortfolioH.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=17,FMT=*)b_policy(i,1) / ( b_policy(i,1) + m_policy(i,1) ) , m_policy(i,1) / ( b_policy(i,1) + m_policy(i,1) )
end do

open (UNIT=18,FILE='PortfolioL.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=18,FMT=*)b_policy(i,nx) / ( b_policy(i,nx) + m_policy(i,nx) ) , m_policy(i,nx) / ( b_policy(i,nx) + m_policy(i,nx) )
end do

open (UNIT=19,FILE='Shares.txt',STATUS='replace')
do i=1,5
WRITE(UNIT=19,FMT=*)ytar(i,1),etar(i,1),astar(i,1),transtar(i,1),ctar(i,1),portshare(i,1),btar(i,1),mtar(i,1)
end do

open (UNIT=20,FILE='Aggregates.txt',STATUS='replace')
WRITE(UNIT=20,FMT=*)Y,C,H,B,M,K,L,G,TR,AY,inf,R_star,tau_k,tau_h,tau,w

elseif (inf == .0) then

open (UNIT=4,FILE='Wealth0.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=4,FMT=*)asset(i,1),a_policy(i,1),a_policy(i,2),a_policy(i,3),sum(invasset(i,:))
end do

open (UNIT=1,FILE='A_prime0.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=1,FMT=*)a_policy(i,1),a_policy(i,2),a_policy(i,3)
end do

open (UNIT=1,FILE='B_prime0.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=1,FMT=*)b_policy(i,1),b_policy(i,2),b_policy(i,3)
end do

open (UNIT=2,FILE='K_prime0.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=2,FMT=*)K_a_x,K_a_x,K_a_x
end do

open (UNIT=2,FILE='L_prime0.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=2,FMT=*)L_a_x,L_a_x,L_a_x
end do

open (UNIT=3,FILE='M_prime0.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=3,FMT=*)m_policy(i,1),m_policy(i,2),m_policy(i,3)
end do

open (UNIT=5,FILE='C_prime0.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=5,FMT=*)c_policy(i,1),c_policy(i,2),c_policy(i,3)
end do

open (UNIT=6,FILE='H_prime0.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=6,FMT=*)h_policy(i,1),h_policy(i,2),h_policy(i,3)
end do

open (UNIT=7,FILE='Value0.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=7,FMT=*)V(i,1),V(i,2),V(i,3)
end do

open (UNIT=8,FILE='y0.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=8,FMT=*)y_disp(i,1),y_disp(i,2),y_disp(i,3)
end do

open (UNIT=9,FILE='A_dist0.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=9,FMT=*)invasset(i,1),invasset(i,2),invasset(i,3)
end do

open (UNIT=10,FILE='WealthIneq0.txt',STATUS='replace')
do i=1,na+1
WRITE(UNIT=10,FMT=*)acdf(i,1),alorenz(i,1)
end do

open (UNIT=11,FILE='IncomeIneq0.txt',STATUS='replace')
do i=1,na*nx +1
WRITE(UNIT=11,FMT=*)ycdf(i,1),ylorenz(i,1)
end do

open (UNIT=12,FILE='PortfolioIneq0.txt',STATUS='replace')
do i=1,na*nx+1
WRITE(UNIT=12,FMT=*)b_cdf(i,1),b_lorenz(i,1),m_cdf(i,1),m_lorenz(i,1),c_cdf(i,1),c_lorenz(i,1)
end do

open (UNIT=13,FILE='Bonds0.txt',STATUS='replace')
do i=1,na*nx
WRITE(UNIT=13,FMT=*)b_sorted(i),bpdf_sorted(i)
end do

open (UNIT=14,FILE='Money0.txt',STATUS='replace')
do i=1,na*nx
WRITE(UNIT=14,FMT=*)m_sorted(i),mpdf_sorted(i)
end do

open (UNIT=15,FILE='Income0.txt',STATUS='replace')
do i=1,na*nx
WRITE(UNIT=15,FMT=*)y_sorted(i),ypdf_sorted(i)!,earn_inc(i),asset_inc(i),trans_inc(i)
end do

open (UNIT=16,FILE='Consumption0.txt',STATUS='replace')
do i=1,na*nx
WRITE(UNIT=16,FMT=*)c_sorted(i),cpdf_sorted(i)
end do

open (UNIT=17,FILE='PortfolioH0.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=17,FMT=*)b_policy(i,1) / ( b_policy(i,1) + m_policy(i,1) ) , m_policy(i,1) / ( b_policy(i,1) + m_policy(i,1) )
end do

open (UNIT=18,FILE='PortfolioL0.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=18,FMT=*)b_policy(i,nx) / ( b_policy(i,nx) + m_policy(i,nx) ) , m_policy(i,nx) / ( b_policy(i,nx) + m_policy(i,nx) )
end do

open (UNIT=19,FILE='Shares0.txt',STATUS='replace')
do i=1,5
WRITE(UNIT=19,FMT=*)ytar(i,1),etar(i,1),astar(i,1),transtar(i,1),ctar(i,1),portshare(i,1),btar(i,1),mtar(i,1)
end do

open (UNIT=20,FILE='Aggregates0.txt',STATUS='replace')
WRITE(UNIT=20,FMT=*)Y,C,H,B,M,K,L,G,TR,AY,inf,R_star,tau_k,tau_h,tau,w


PS = tau_k*(Y-delta*K-w*L) + tau_h*w*H + inf*M/(1+inf) - G - tau

elseif (inf == 0.14) then

open (UNIT=4,FILE='Wealth10.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=4,FMT=*)asset(i,1),a_policy(i,1),a_policy(i,2),a_policy(i,3),sum(invasset(i,:))
end do

open (UNIT=1,FILE='A_prime10.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=1,FMT=*)a_policy(i,1),a_policy(i,2),a_policy(i,3)
end do

open (UNIT=1,FILE='B_prime10.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=1,FMT=*)b_policy(i,1),b_policy(i,2),b_policy(i,3)
end do

open (UNIT=2,FILE='K_prime10.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=2,FMT=*)K_a_x,K_a_x,K_a_x
end do

open (UNIT=2,FILE='L_prime10.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=2,FMT=*)L_a_x,L_a_x,L_a_x
end do

open (UNIT=3,FILE='M_prime10.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=3,FMT=*)m_policy(i,1),m_policy(i,2),m_policy(i,3)
end do

open (UNIT=5,FILE='C_prime10.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=5,FMT=*)c_policy(i,1),c_policy(i,2),c_policy(i,3)
end do

open (UNIT=6,FILE='H_prime10.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=6,FMT=*)h_policy(i,1),h_policy(i,2),h_policy(i,3)
end do

open (UNIT=6,FILE='Kappa_prime10.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=6,FMT=*)kap_policy(i,1),kap_policy(i,2),kap_policy(i,3)
end do

open (UNIT=7,FILE='Value10.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=7,FMT=*)V(i,1),V(i,2),V(i,3)
end do

open (UNIT=8,FILE='y10.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=8,FMT=*)y_disp(i,1),y_disp(i,2),y_disp(i,3)
end do

open (UNIT=9,FILE='A_dist10.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=9,FMT=*)invasset(i,1),invasset(i,2),invasset(i,3)
end do

open (UNIT=10,FILE='WealthIneq10.txt',STATUS='replace')
do i=1,na+1
WRITE(UNIT=10,FMT=*)acdf(i,1),alorenz(i,1)
end do

open (UNIT=11,FILE='IncomeIneq10.txt',STATUS='replace')
do i=1,na*nx +1
WRITE(UNIT=11,FMT=*)ycdf(i,1),ylorenz(i,1)
end do

open (UNIT=12,FILE='PortfolioIneq10.txt',STATUS='replace')
do i=1,na*nx+1
WRITE(UNIT=12,FMT=*)b_cdf(i,1),b_lorenz(i,1),m_cdf(i,1),m_lorenz(i,1),c_cdf(i,1),c_lorenz(i,1),fin_cdf(i,1),fin_lorenz(i,1)
end do

open (UNIT=13,FILE='Deposits10.txt',STATUS='replace')
do i=1,na*nx
WRITE(UNIT=13,FMT=*)fin_sorted(i),finpdf_sorted(i)
end do

open (UNIT=13,FILE='Bonds10.txt',STATUS='replace')
do i=1,na*nx
WRITE(UNIT=13,FMT=*)b_sorted(i),bpdf_sorted(i)
end do

open (UNIT=14,FILE='Money10.txt',STATUS='replace')
do i=1,na*nx
WRITE(UNIT=14,FMT=*)m_sorted(i),mpdf_sorted(i)
end do

open (UNIT=15,FILE='Income10.txt',STATUS='replace')
do i=1,na*nx
WRITE(UNIT=15,FMT=*)y_sorted(i),ypdf_sorted(i)!,earn_inc(i),asset_inc(i),trans_inc(i)
end do

open (UNIT=16,FILE='Consumption10.txt',STATUS='replace')
do i=1,na*nx
WRITE(UNIT=16,FMT=*)c_sorted(i),cpdf_sorted(i)
end do

open (UNIT=17,FILE='PortfolioH10.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=17,FMT=*)b_policy(i,1) / ( b_policy(i,1) + m_policy(i,1) ) , m_policy(i,1) / ( b_policy(i,1) + m_policy(i,1) )
end do

open (UNIT=18,FILE='PortfolioL10.txt',STATUS='replace')
do i=1,na
WRITE(UNIT=18,FMT=*)b_policy(i,nx) / ( b_policy(i,nx) + m_policy(i,nx) ) , m_policy(i,nx) / ( b_policy(i,nx) + m_policy(i,nx) )
end do

open (UNIT=19,FILE='Shares10.txt',STATUS='replace')
do i=1,5
WRITE(UNIT=19,FMT=*)ytar(i,1),etar(i,1),astar(i,1),transtar(i,1),ctar(i,1),portshare(i,1),btar(i,1),mtar(i,1)
end do

open (UNIT=20,FILE='Aggregates10.txt',STATUS='replace')
WRITE(UNIT=20,FMT=*)Y,C,H,B,M,K,L,G,TR,AY,inf,R_star,tau_k,tau_h,tau,w

end if

end subroutine Output
