subroutine osl_quicksort_vwp(v)


    use osl_core, wp => osl_wp
    implicit none

    real(wp), dimension(:), intent(inout) :: v
    integer, parameter :: m = 7
    integer :: n_stack = 50
    integer, dimension(:), allocatable :: s, s_temp
    integer :: i, ir, j, k, jstack, l, n
    real(wp) :: a

    ! initialize stack
    allocate(s(n_stack))

    n = size(v)

    jstack = 0
    l = 1
    ir = n

    do
       if (ir - l < m) then
          do j = l + 1, ir
             a = v(j)
             do i = j - 1 , 1, -1
                if (v(i) <= a) exit
                v(i+1) = v(i)
             end do
             v(i+1) = a
          end do

          if (jstack == 0) return

          ir = s(jstack)
          l = s(jstack-1)
          jstack = jstack - 2

       else

          k = (l+ir)/2
          call osl_swap(v(k),v(l+1))
          if (v(l+1) > v(ir)) call osl_swap(v(l+1), v(ir))
          if (v(l) > v(ir)) call osl_swap(v(l), v(ir))
          if (v(l+1) > v(l)) call osl_swap(v(l+1), v(l))

          i = l + 1
          j = ir
          a = v(l)

          do
             do
                i = i + 1
                if (v(i) >= a) exit
             end do

             do
                j = j - 1
                if (v(j) <= a) exit
             end do

             if (j < i) exit
             call osl_swap(v(i), v(j))
          end do

          v(l) = v(j)
          v(j) = a
          jstack = jstack + 2

          ! double the stack size if necessary
          if (jstack > n_stack) then
             allocate(s_temp(n_stack))
             s_temp = s
             deallocate(s)
             n_stack = 2 * n_stack
             allocate(s(n_stack))
             s(1:size(s_temp,1)) = s_temp
             deallocate(s_temp)
          end if

          if (ir - i + 1 > j - l) then
             s(jstack) = ir
             s(jstack-1) = i
             ir = j-1
          else
             s(jstack) = j-1
             s(jstack-1) = l
             l = i
          end if
       end if
    end do

    ! free stack
    deallocate(s)
  end subroutine osl_quicksort_vwp
