MODULE parameters

!----------------------------------------------
!! Precision parameters
!----------------------------------------------
use osl_core, wp => osl_wp

INTEGER, PARAMETER :: DP = KIND(1.0D0)

INTEGER, PARAMETER :: SP = KIND(1.0)

!----------------------------------------------
!! Earnings process
!----------------------------------------------

integer, parameter :: nx = 3                                ! Number of earnings grid points

real(wp), parameter :: beta =  0.98137, delta = 0.0375, theta = 0.931 !  beta =  0.98153 delta = 0.0325 theta = 0.92 for the period 1996-2014 share of capital in production, discount factor, depreciation rate, returns-to-scale parameter 0.98445 upper

! Together with theta=.9, alpha implies a capital income share of 40%

real(wp), parameter :: sigma = 2 ,  psi = 70, varrho = 0.23 ! Risk aversion,  multiplicative of labor supply, decreases labor supply, exponent of real money demand the upper bound for varrho = 1.0576 coming from the M1 estimation

! 0.9731413 is the upper bound for beta psi = 70, varrho = 0.275

real(wp), parameter :: cover = 3._dp                        ! Coverage of normal distribution

real(wp), dimension(nx,1) :: z                              ! Log of earnings points

real(wp), dimension(nx,nx) :: xprob                     ! Transition matrix

real(DP),dimension(nx,1) :: x,invx,invx1,difx               ! Earnings grid, invariant distribution of earnings process

real(DP) :: alpha = 1- .62/theta, var_x,sigma_x, x_bar       ! Coefficient of variation of the earnings process, mean of the earnings process, standard deviation of shocks

character:: input

integer, parameter ::  na = 400, nb = 25, nm = 8 ! a = 400  m = 120 b = 150 varrho = 0.5 n_asset = 200,

integer :: i,j,t,ii,jj,kk,hh,vv,n,counter,iteration

integer,dimension(na,nx):: indmon,indbond,indcap,indasset,indhour

integer,dimension(na,nx):: I_money,I_bond,I_hour,I_kappa,I_asset ! Indicator functions for policies

integer,dimension(na,nx)::LL,RR

real(DP),dimension(na,nx)::LW,RW

real,dimension(2)::values

real(DP),dimension(3)::enes

integer,dimension(2)::mb_loc

real::time

real(DP) ::phi,gama,eta,inf,inca,incm,inch,incv,incb,inck,incc,inccdf,inclorenz,bh,bl,tol1,bss,mss,inckap

real(DP) ::  tau,tau_k,tau_h,R_star,R_k,w,r_tilde,w_tilde,w1,w2,tau1,tau2,g1,g2,PS,fc,fc1,h1,CEV,rB,&
y_median,c_median,cnext,c_diff

real(DP):: C,H,K,L,Y,A,B,M,G,k_l,TR,AY,AY_p,vlb,vub,hlb,hub,mlb,mub,blb,bub,klb,kub,alb,aub,VFI_check,clb,cub,vel,&
gini_fin,gini_wealth,gini_y,Anorm,gini_m,gini_b,gini_c,H_L,K_H_next,Q,L_a_x,K_a_x,Rk_a_x,kaplb,kapub

real(DP),dimension(na,nx) :: ypdf,y_disp

real(DP),dimension(na*nx) :: y_sorted,ypdf_sorted,m_sorted,mpdf_sorted,b_sorted,bpdf_sorted,k_sorted,kpdf_sorted,c_sorted,&
cpdf_sorted,h_sorted,hpdf_sorted,earn_inc,asset_inc,trans_inc,fin_sorted,finpdf_sorted

real(DP),dimension(na*nx+1,1) :: ycdf,ylorenz,yi_cdf,yi_lorenz,m_cdf,m_lorenz,b_cdf,b_lorenz,k_cdf,k_lorenz,c_cdf,c_lorenz,&
h_cdf,h_lorenz,fin_cdf,fin_lorenz

real(DP),dimension(nb,1) :: bond,normb

real(DP),dimension(nm,1) :: money, kappa

real(DP),dimension(nb/2,1) :: bond1,bond2

real(DP),dimension(nm/2,1) :: money1,money2

real(DP),dimension(na,1) ::asset,norma

real(DP),dimension(na+1,1) :: acdf,alorenz

real(DP),dimension(5,1)::mtar,btar,fintar,ctar,ytar,etar,astar,transtar,portshare

integer ::Lprime,Rprime

real(DP)::aprime,lwprime,rwprime

real(DP),dimension(na,nx):: V, Vnext, diff, invasset,trans,Policy

real(DP),dimension(na,nx,nb):: Viter, Citer

real(DP)::cons,u,mon,hour,labor,kap,kap1

real(DP),dimension(na,nx):: b_policy,m_policy,a_policy,c_policy,h_policy,kap_policy

real(DP)::first,second,third,fourth,timesum,scalar1,scalar2,scalar3,scalar4,scalar5,scalar6,scalar7,scalar8,scalar9

END MODULE
